import java.sql.Time;
import java.util.List;
import java.util.RandomAccess;
import java.util.Timer;
import java.util.Vector;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.RandomAccessFile;
import java.net.*;

public class Client {
	private FileInputStream arquivo;
	private File arquivoTemp;
	private RandomAccessFile randomFile;
	private Vector<Packet> pacotes;
	private int numeroDoPacote = 1;
	InetAddress IPAddress;
	DatagramPacket sendPacket;
	DatagramPacket receivePacket;
	DatagramSocket clientSocket;
	Timer timeout;

	Client() throws Exception {

		clientSocket = new DatagramSocket();
		IPAddress = InetAddress.getByName("172.17.68.34");
		this.criarPacotes();
		arquivo = new FileInputStream("H:\\y.txt");
		arquivoTemp = new File("H:\\y.txt");
		randomFile = new RandomAccessFile(arquivoTemp, "r");
		timeout = new Timer();

	}

	public void dividirArquivo() throws Exception {

	}

	public int qtidadePacotes() throws Exception { // retorna a quantidade de pacotes a ser enviadas

		int tamanhoArquivo = (int) arquivoTemp.length();
		int qtidadeDePacotes = tamanhoArquivo / 525;
		if (tamanhoArquivo % 525 > 0) {

			qtidadeDePacotes = qtidadeDePacotes + 1;
		}
		return qtidadeDePacotes;

	}

	public byte[] intToByteArray(int value) { // transforma inteiro pra byte
		byte[] b = new byte[4];
		for (int i = 0; i < 4; i++) {
			int offset = (b.length - 1 - i) * 8;
			b[i] = (byte) ((value >>> offset) & 0xFF);
		}
		return b;
	}

	public void inserirNumeroSequencia(int intArg) throws Exception {

		byte[] b;

		b = this.intToByteArray((numeroDoPacote - 1) * Constantes.MSS);
		pacotes.elementAt(intArg).setNumeroSequencia(b);

		//b = this.intToByteArray(x*536);

	}

	public void criarPacotes() throws Exception {

		this.pacotes = new Vector<Packet>(0);
		int x = 0;
		while (arquivo.available() > 0 && pacotes.size() < 100) {
			arquivo.read(pacotes.elementAt(x).getPacote(), 11, 525);
			this.enviarPacotes(pacotes.elementAt(x));
		}
		x++;
	}

	public void inserirPacotes(Packet pacoteArg) {

		this.pacotes.add(pacoteArg);
	}

	public boolean pacoteRecebido(int index) {
		boolean recebeu = false;
		return recebeu;
	}

	public void pedirConexao() {

		this.enviarAckSyn();

	}

	private void enviarAckSyn() {

		Packet pacoteTemp = new Packet();

		pacoteTemp.setFlag(Constantes.FLAG_SYN);

		byte[] b = intToByteArray(50);

		pacoteTemp.setNumeroSequencia(b);

		pacoteTemp.gerarPacoteTotal();

		enviarPacotes(pacoteTemp);

	}

	public boolean ackRecebido(Packet pacoteArg) throws IOException {

		boolean recebeuAck = false;

		Packet pacoteTemp = new Packet();

		receivePacket = new DatagramPacket(pacoteTemp.getPacote(), pacoteTemp
				.getPacote().length);

		clientSocket.receive(receivePacket);

		if (pacoteTemp.getNumeroDeReconhecimento().equals(
				pacoteArg.getNumeroSequencia())) {

			recebeuAck = true;

		}
		
		return recebeuAck;

	}

	public void enviarPacotes(Packet packetArg) {

		sendPacket = new DatagramPacket(packetArg.getPacote(), packetArg
				.getPacote().length, IPAddress, 9000);
		packetArg.

		timeout.scheduleAtFixedRate(task, firstTime, period);

	}
	
	public Vector<Packet> getVector(){
		return pacotes;
	}

}
