import java.util.Timer;
import java.util.TimerTask;

public class Packet {

	private byte[] numeroDeSequencia;
	private byte[] numeroDeReconhecimento;
	private byte flags;
	private byte[] pacote;
	private byte[] janelaDeRecepcao;
	private byte[] dados;
	private Timer timeout;
	private TimerTask task;
	private boolean confirma;

	public Packet() {

		numeroDeSequencia = new byte[4];
		numeroDeReconhecimento = new byte[4];
		janelaDeRecepcao = new byte[2];
		pacote = new byte[536];
		confirma = false;
		
		
		
		//dados = new byte[525];

	}

	public byte[] getNumeroSequencia() {

		return numeroDeSequencia;
	}

	public byte[] getNumeroDeReconhecimento() {

		return numeroDeReconhecimento;
	}

	public byte[] getJanelaDeRecepcao() {

		janelaDeRecepcao[0] = pacote[8];
		janelaDeRecepcao[1] = pacote[9];

		return janelaDeRecepcao;
	}

	public byte getFlag() {
		return flags;
	}

	public byte[] getPacote() {
		return pacote;

	}

	public void setNumeroSequencia(byte[] byteArg) {

		for (int x = 0; x < 4; x++) {
			numeroDeSequencia[x] = byteArg[x];

		}

	}

	public void setDados(byte[] byteArg) {

		dados = byteArg;

	}

	/*public byte[] getDados() {

		return dados;

	}*/

	public void setFlag(byte byteArg) {

		flags = byteArg;

	}

	public void gerarPacoteTotal() {

		for (int x = 0; x < 4; x++)
			pacote[x] = this.numeroDeSequencia[x];

		for (int x = 4; x < 8; x++)
			pacote[x] = this.numeroDeReconhecimento[x - 4];

		for (int x = 8; x < 10; x++)
			pacote[x] = this.janelaDeRecepcao[x - 8];

		pacote[10] = flags;

	}
	
	public void setTime (Client client){
		
		timeout = new Timer();
		timeout.schedule(task, 200);		
		
	}
	
	public boolean getConfirma(){
		return confirma;
	}
	
	public void setConfirma(boolean arg){
		confirma = arg;
	}
	
	
	

}
